<?php 

/*
 * expand.php
 * This script alters the session variable 'tree', expanding it
 * at the dn specified in the query string. 
 *
 * Variables that come in as GET vars:
 *  - dn (rawurlencoded)
 *  - server_id
 *
 * Note: this script is equal and opposite to collapse.php
 */

require 'config.php';
require_once 'functions.php';

$dn = stripslashes( $_GET['dn'] );
$encoded_dn = rawurlencode( $dn );
$server_id = $_GET['server_id'];

check_server_id( $server_id ) or davedap_error( "Bad server_id: " . htmlentities( $server_id ) );
have_auth_info( $server_id ) or davedap_error( "Not enough information to login to server. Please check your configuration." );

session_start();
assert( isset( $servers[$server_id] ) );
assert( session_is_registered( 'tree' ) );
$tree = $_SESSION['tree'];
$tree_icons = $_SESSION['tree_icons'];

davedap_ldap_connect( $server_id ) or davedap_error( "Could not connect to LDAP server" );
$contents = get_container_contents( $server_id, $dn );

sort( $contents );
$tree[$server_id][$dn] = $contents;

foreach( $contents as $dn )
	$tree_icons[$server_id][$dn] = get_icon( $server_id, $dn );

$_SESSION['tree'] = $tree;
$_SESSION['tree_icons'] = $tree_icons;
session_write_close();

header( "Location: tree.php#{$server_id}_{$encoded_dn}" );

?>
